=== debian/changelog ===
srpc (0.10.0-2) unstable; urgency=medium

  * d/clean: Remove autogenerated files (Closes: #1046697)
  * d/upstream/metadata: Add upstream metadata

 -- Lance Lin <lq27267@gmail.com>  Wed, 16 Aug 2023 19:21:21 +0700

srpc (0.10.0-1) unstable; urgency=medium

  * Update to new version (0.10.0)
  * d/patches: refresh remove-tutorial-check-targets.patch
  * d/libsrpc0.install: Use wildcard for version number

 -- Lance Lin <lq27267@gmail.com>  Tue, 30 May 2023 23:45:27 +0700
