## srpc 0.10.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.10.0
+	VERSION 0.10.1
 	LANGUAGES C CXX)
 	
 ###Options
@@ -17,11 +17,17 @@
 include(CheckIncludeFile)
 include(CheckIncludeFileCXX)
 
+set(THIRD_PARTY_FATAL_MESSAGE
+" is neither installed nor found in third_party!
+Sugguestion to initial third_party:
+	\"git submodule update --init\""
+)
+
 find_library(LZ4_LIBRARY NAMES lz4)
 check_include_file("lz4.h" LZ4_INSTALLED)
 if (NOT LZ4_INSTALLED AND ${LZ4_LIBRARY} STREQUAL "LZ4_LIBRARY-NOTFOUND")
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
-		message( FATAL_ERROR "Lz4 is neither installed not in third_party!")
+		message( FATAL_ERROR "\nLz4" ${THIRD_PARTY_FATAL_MESSAGE} )
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
@@ -38,7 +44,7 @@
 check_include_file_cxx("snappy.h" SNAPPY_INSTALLED)
 if (NOT SNAPPY_INSTALLED AND NOT ${Snappy_FOUND})
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
-		message( FATAL_ERROR "Snappy is neither installed not in third_party!")
+		message( FATAL_ERROR "\nSnappy" ${THIRD_PARTY_FATAL_MESSAGE} )
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
@@ -54,7 +60,7 @@
 check_include_file_cxx("workflow/Workflow.h" WORKFLOW_INSTALLED)
 if (NOT WORKFLOW_INSTALLED)
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
-		message( FATAL_ERROR "Workflow is neither installed not in third_party!")
+		message( FATAL_ERROR "\nWorkflow" ${THIRD_PARTY_FATAL_MESSAGE} )
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
