=== debian/changelog ===
srpc (0.10.1-1) unstable; urgency=medium

  * New upstream version
  * Reorder sequence of d/control fields by cme (routine-update)
  * d/patches: Update patch header to include missing fields

 -- Lance Lin <lq27267@gmail.com>  Mon, 08 Jan 2024 20:28:03 +0700
