=== debian/control ===
Source: srpc
Maintainer: Lance Lin <lq27267@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libworkflow-dev,
               libssl-dev,
               libsnappy-dev,
               libprotobuf-dev,
               protobuf-compiler,
               liblz4-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/srpc
Vcs-Git: https://salsa.debian.org/debian/srpc.git
Homepage: https://github.com/sogou/srpc
Rules-Requires-Root: no

Package: libsrpc0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsrpc (<< 0.9.7-1)
Replaces: libsrpc (<< 0.9.7-1)
Description: Sogou RPC (SRPC) Runtime Library
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the runtime library.

Package: libsrpc-dev
Architecture: any
Multi-Arch: same
Depends: libsrpc0 (= ${binary:Version}),
         libsrpc-bin (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsrpc (<< 0.9.7-1)
Replaces: libsrpc (<< 0.9.7-1)
Description: Sogou RPC Library (SRPC)
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the development header files.

Package: libsrpc-bin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsrpc (<< 0.9.7-1)
Replaces: libsrpc (<< 0.9.7-1)
Description: Sogou RPC Library (SRPC) Generator
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the IDL file generator, srpc_generator
