## srpc 0.10.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.10.1
+	VERSION 0.10.2
 	LANGUAGES C CXX)
 	
 ###Options
