=== src/CMakeLists.txt ===
--- 
+++ 
@@ -83,6 +83,10 @@
 add_dependencies(compress LINK_HEADERS)
 add_dependencies(message LINK_HEADERS)
 
+if (NOT WIN32)
+	add_subdirectory(http)
+	add_dependencies(http LINK_HEADERS)
+endif ()
 
 if (WIN32)
 	add_library(
@@ -114,6 +118,7 @@
 else ()
 	set(STATIC_LIB_NAME ${PROJECT_NAME}-static)
 	set(SHARED_LIB_NAME ${PROJECT_NAME}-shared)
+	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
 	link_directories(${OPENSSL_LINK_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
 
 	add_library(
@@ -124,6 +129,7 @@
 		$<TARGET_OBJECTS:thrift>
 		$<TARGET_OBJECTS:compress>
 		$<TARGET_OBJECTS:message>
+		$<TARGET_OBJECTS:http>
 	)
 
 	add_library(
@@ -134,16 +140,21 @@
 		$<TARGET_OBJECTS:thrift>
 		$<TARGET_OBJECTS:compress>
 		$<TARGET_OBJECTS:message>
+		$<TARGET_OBJECTS:http>
 	)
 
-	target_link_libraries(${SHARED_LIB_NAME} 
-						  OpenSSL::SSL
-						  OpenSSL::Crypto
-						  pthread
-						  protobuf
-						  workflow
-						  z ${SNAPPY_LIB} ${LZ4_LIB})
-		
+	if (APPLE)
+		target_link_libraries(${SHARED_LIB_NAME}
+							  OpenSSL::SSL
+							  OpenSSL::Crypto
+							  pthread
+							  ${Protobuf_LIBRARY}
+							  workflow
+							  z ${SNAPPY_LIB} ${LZ4_LIB})
+	else ()
+		target_link_libraries(${SHARED_LIB_NAME})
+	endif ()
+
 	set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
 	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR} )
