=== src/module/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,6 @@
 	proto/opentelemetry_common.proto
 	proto/opentelemetry_resource.proto
 	proto/opentelemetry_trace.proto
-	proto/opentelemetry_trace_service.proto
 	proto/opentelemetry_metrics.proto
 	proto/opentelemetry_metrics_service.proto)
 
@@ -15,6 +14,8 @@
 
 set(SRC
 	rpc_module.cc
+	rpc_trace_module.cc
+	rpc_metrics_module.cc
 	rpc_trace_filter.cc
 	rpc_metrics_filter.cc
 	${PROTO_SRCS} ${PROTO_HDRS}
@@ -22,3 +23,12 @@
 
 add_library(${PROJECT_NAME} OBJECT ${SRC})
 
+if (WIN32)
+	target_compile_definitions(
+		${PROJECT_NAME} PRIVATE
+		strdup=_strdup
+		strcasecmp=_stricmp
+		strncasecmp=_strnicmp
+	)
+endif ()
+
