=== debian/changelog ===
srpc (0.10.3-3) unstable; urgency=medium

  * d/patches: Fix FTBFS with gtest (Closes: #1114396)
  * d/control: Standards-Version: 4.7.2
  * d/patches: Fix Last-Update format for DEP-3
  * d/copyright: Update copyright to 2025 for debian files

 -- Lance Lin <lq27267@gmail.com>  Mon, 15 Sep 2025 20:56:11 +0700

srpc (0.10.3-2) unstable; urgency=medium

  * d/patches: Enable build tests.
  * d/patches: Enables hardening for build tests.
  * d/clean: Remove build artifacts generated from tests.
  * d/tests: Enable build tests in autopkgtest.

 -- Lance Lin <lq27267@gmail.com>  Tue, 03 Sep 2024 21:32:51 +0700

srpc (0.10.3-1) unstable; urgency=medium

  * New upstream version

 -- Lance Lin <lq27267@gmail.com>  Fri, 07 Jun 2024 20:14:37 +0700

srpc (0.10.2-2) unstable; urgency=medium

  * d/patches: Fix ambiguous call to overloaded function by creating
    an instance of the function (Closes: #1071365)

 -- Lance Lin <lq27267@gmail.com>  Fri, 24 May 2024 19:23:58 +0700

srpc (0.10.2-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)

 -- Lance Lin <lq27267@gmail.com>  Thu, 25 Apr 2024 22:37:28 +0700

srpc (0.10.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062923

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:26:31 +0000
