=== debian/control ===
--- 
+++ 
@@ -2,27 +2,29 @@
 Maintainer: Lance Lin <lq27267@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: cmake,
+Build-Depends: dpkg-dev (>= 1.22.5), cmake,
                debhelper-compat (= 13),
                libworkflow-dev,
                libssl-dev,
+               libgtest-dev,
                libsnappy-dev,
                libprotobuf-dev,
                protobuf-compiler,
                liblz4-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/srpc
 Vcs-Git: https://salsa.debian.org/debian/srpc.git
 Homepage: https://github.com/sogou/srpc
 Rules-Requires-Root: no
 
-Package: libsrpc0
+Package: libsrpc0t64
+Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Breaks: libsrpc (<< 0.9.7-1)
-Replaces: libsrpc (<< 0.9.7-1)
+Breaks: libsrpc0 (<< ${source:Version}), libsrpc (<< 0.9.7-1)
+Replaces: libsrpc0, libsrpc (<< 0.9.7-1)
 Description: Sogou RPC (SRPC) Runtime Library
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
@@ -36,7 +38,7 @@
 Package: libsrpc-dev
 Architecture: any
 Multi-Arch: same
-Depends: libsrpc0 (= ${binary:Version}),
+Depends: libsrpc0t64 (= ${binary:Version}),
          libsrpc-bin (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
