=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/srpc-$1\.tar\.gz/ \
  https://github.com/sogou/srpc/tags .*/v?(\d\S+)\.tar\.gz
